From 166c6be9f12b38adef21fde5d9446e4af26b2f36 Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Wed, 29 May 2019 18:13:22 -0700
Subject: [PATCH] IPC Router Core: Send Hello reply for a received Hello
 message

---
 net/ipc_router/ipc_router_core.c | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)
 mode change 100644 => 100755 net/ipc_router/ipc_router_core.c

diff --git a/net/ipc_router/ipc_router_core.c b/net/ipc_router/ipc_router_core.c
old mode 100644
new mode 100755
index 895bcea..fd9b2e3
--- a/net/ipc_router/ipc_router_core.c
+++ b/net/ipc_router/ipc_router_core.c
@@ -52,7 +52,7 @@ module_param_named(debug_mask, msm_ipc_router_debug_mask,
 		   int, S_IRUGO | S_IWUSR | S_IWGRP);
 #define MODULE_NAME "ipc_router"
 
-#define IPC_RTR_INFO_PAGES 6
+#define IPC_RTR_INFO_PAGES 100
 
 #define IPC_RTR_INFO(log_ctx, x...) do { \
 if (log_ctx) \
@@ -151,6 +151,7 @@ struct msm_ipc_router_xprt_info {
 	struct kref ref;
 	struct completion ref_complete;
 	bool hello_sent;
+	bool hello_rcvd;
 };
 
 #define RT_HASH_SIZE 4
@@ -2477,7 +2478,7 @@ static int do_send_hello_msg(struct msm_ipc_router_xprt_info *xprt_info)
 	union rr_control_msg ctl;
 	int rc = 0;
 
-	if (xprt_info->hello_sent)
+	if (xprt_info->hello_sent && xprt_info->hello_rcvd)
 		return 0;
 
 	memset(&ctl, 0, sizeof(ctl));
@@ -2517,6 +2518,10 @@ static int process_hello_msg(struct msm_ipc_router_xprt_info *xprt_info,
 	do_version_negotiation(xprt_info, msg);
 	do_send_hello_msg(xprt_info);
 	xprt_info->initialized = 1;
+        if (xprt_info->hello_rcvd == true)
+		IPC_RTR_ERR("Recieved duplicate Hello message for XPRT %s \n",
+				 xprt_info->xprt->name);
+        xprt_info->hello_rcvd = true;
 
 	/* Send list of servers from the local node and from nodes
 	 * outside the mesh network in which this XPRT is part of.
@@ -4102,6 +4107,7 @@ static int msm_ipc_router_add_xprt(struct msm_ipc_router_xprt *xprt)
 	up_write(&xprt_info_list_lock_lha5);
 
 	xprt_info->hello_sent = false;
+	xprt_info->hello_rcvd = false;
 	do_send_hello_msg(xprt_info);
 
 	down_write(&routing_table_lock_lha3);
-- 
1.9.1

